Package org.codehaus.groovy.groovydoc

# Interface GroovyProgramElementDoc

All Superinterfaces:
  `Comparable<GroovyDoc>`, `GroovyDoc`

All Known Subinterfaces:
  `GroovyClassDoc`, `GroovyConstructorDoc`, `GroovyExecutableMemberDoc`, `GroovyFieldDoc`, `GroovyMemberDoc`, `GroovyMethodDoc`

All Known Implementing Classes:
  `ArrayClassDocWrapper`, `ExternalGroovyClassDoc`, `SimpleGroovyAbstractableElementDoc`, `SimpleGroovyClassDoc`, `SimpleGroovyConstructorDoc`, `SimpleGroovyExecutableMemberDoc`, `SimpleGroovyFieldDoc`, `SimpleGroovyMemberDoc`, `SimpleGroovyMethodDoc`, `SimpleGroovyProgramElementDoc`

public interface GroovyProgramElementDoc extends GroovyDoc
Describes a documented program element that can appear within a package or type.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `GroovyAnnotationRef[]`
  `annotations()`
  Returns the annotations declared on this element.
  `GroovyClassDoc`
  `containingClass()`
  Returns the containing class for this element.
  `GroovyPackageDoc`
  `containingPackage()`
  Returns the package that contains this element.
  `boolean`
  `isFinal()`
  Indicates whether this element is declared `final`.
  `boolean`
  `isPackagePrivate()`
  Indicates whether this element has package-private visibility.
  `boolean`
  `isPrivate()`
  Indicates whether this element is declared `private`.
  `boolean`
  `isProtected()`
  Indicates whether this element is declared `protected`.
  `boolean`
  `isPublic()`
  Indicates whether this element is declared `public`.
  `boolean`
  `isStatic()`
  Indicates whether this element is declared `static`.
  `String`
  `modifiers()`
  Returns the rendered modifier text for this element.
  `int`
  `modifierSpecifier()`
  Returns the modifier flags for this element.
  `String`
  `qualifiedName()`
  Returns the fully qualified name of this element.

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface org.codehaus.groovy.groovydoc.GroovyDoc

  `commentText, firstSentenceCommentText, getRawCommentText, isAnnotationType, isAnnotationTypeElement, isClass, isConstructor, isDeprecated, isEnum, isEnumConstant, isError, isException, isField, isIncluded, isInterface, isMethod, isOrdinaryClass, isRecord, name, setRawCommentText`

- ## Method Details

  - ### annotations

    GroovyAnnotationRef[] annotations()
    Returns the annotations declared on this element.
    Returns:
      the declared annotations

  - ### containingClass

    GroovyClassDoc containingClass()
    Returns the containing class for this element.
    Returns:
      the containing class, or `null` if this element is not nested within a class

  - ### containingPackage

    GroovyPackageDoc containingPackage()
    Returns the package that contains this element.
    Returns:
      the containing package, or `null` if none is available

  - ### isFinal

    boolean isFinal()
    Indicates whether this element is declared `final`.
    Returns:
      `true` if this element is final

  - ### isPackagePrivate

    boolean isPackagePrivate()
    Indicates whether this element has package-private visibility.
    Returns:
      `true` if this element is package-private

  - ### isPrivate

    boolean isPrivate()
    Indicates whether this element is declared `private`.
    Returns:
      `true` if this element is private

  - ### isProtected

    boolean isProtected()
    Indicates whether this element is declared `protected`.
    Returns:
      `true` if this element is protected

  - ### isPublic

    boolean isPublic()
    Indicates whether this element is declared `public`.
    Returns:
      `true` if this element is public

  - ### isStatic

    boolean isStatic()
    Indicates whether this element is declared `static`.
    Returns:
      `true` if this element is static

  - ### modifiers

    String modifiers()
    Returns the rendered modifier text for this element.
    Returns:
      the modifier text

  - ### modifierSpecifier

    int modifierSpecifier()
    Returns the modifier flags for this element.
    Returns:
      the modifier bit set

  - ### qualifiedName

    String qualifiedName()
    Returns the fully qualified name of this element.
    Returns:
      the qualified name